diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/admin-bar.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/admin-bar.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/admin-bar.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/admin-bar.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 341,352 ****
  		),
  	) );
  
- 	$blue_wp_logo_url = includes_url('images/wpmini-blue.png');
- 
  	foreach ( (array) $wp_admin_bar->user->blogs as $blog ) {
! 		// @todo Replace with some favicon lookup.
! 		//$blavatar = '<img src="' . esc_url( blavatar_url( blavatar_domain( $blog->siteurl ), 'img', 16, $blue_wp_logo_url ) ) . '" alt="Blavatar" width="16" height="16" />';
! 		$blavatar = '<img src="' . esc_url($blue_wp_logo_url) . '" alt="' . esc_attr__( 'Blavatar' ) . '" width="16" height="16" class="blavatar"/>';
  
  		$blogname = empty( $blog->blogname ) ? $blog->domain : $blog->blogname;
  		$menu_id  = 'blog-' . $blog->userblog_id;
--- 341,350 ----
  		),
  	) );
  
  	foreach ( (array) $wp_admin_bar->user->blogs as $blog ) {
! 		switch_to_blog( $blog->userblog_id );
! 
! 		$blavatar = '<div class="blavatar"></div>';
  
  		$blogname = empty( $blog->blogname ) ? $blog->domain : $blog->blogname;
  		$menu_id  = 'blog-' . $blog->userblog_id;
***************
*** 355,382 ****
  			'parent'    => 'my-sites-list',
  			'id'        => $menu_id,
  			'title'     => $blavatar . $blogname,
! 			'href'      => get_admin_url( $blog->userblog_id ),
  		) );
  
  		$wp_admin_bar->add_menu( array(
  			'parent' => $menu_id,
  			'id'     => $menu_id . '-d',
  			'title'  => __( 'Dashboard' ),
! 			'href'   => get_admin_url( $blog->userblog_id ),
  		) );
  
! 		if ( current_user_can_for_blog( $blog->userblog_id, 'edit_posts' ) ) {
  			$wp_admin_bar->add_menu( array(
  				'parent' => $menu_id,
  				'id'     => $menu_id . '-n',
  				'title'  => __( 'New Post' ),
! 				'href'   => get_admin_url( $blog->userblog_id, 'post-new.php' ),
  			) );
  			$wp_admin_bar->add_menu( array(
  				'parent' => $menu_id,
  				'id'     => $menu_id . '-c',
  				'title'  => __( 'Manage Comments' ),
! 				'href'   => get_admin_url( $blog->userblog_id, 'edit-comments.php' ),
  			) );
  		}
  
--- 353,383 ----
  			'parent'    => 'my-sites-list',
  			'id'        => $menu_id,
  			'title'     => $blavatar . $blogname,
! 			'href'      => admin_url(),
  		) );
  
  		$wp_admin_bar->add_menu( array(
  			'parent' => $menu_id,
  			'id'     => $menu_id . '-d',
  			'title'  => __( 'Dashboard' ),
! 			'href'   => admin_url(),
  		) );
  
! 		if ( current_user_can( get_post_type_object( 'post' )->cap->create_posts ) ) {
  			$wp_admin_bar->add_menu( array(
  				'parent' => $menu_id,
  				'id'     => $menu_id . '-n',
  				'title'  => __( 'New Post' ),
! 				'href'   => admin_url( 'post-new.php' ),
  			) );
+ 		}
+ 
+ 		if ( current_user_can( 'edit_posts' ) ) {
  			$wp_admin_bar->add_menu( array(
  				'parent' => $menu_id,
  				'id'     => $menu_id . '-c',
  				'title'  => __( 'Manage Comments' ),
! 				'href'   => admin_url( 'edit-comments.php' ),
  			) );
  		}
  
***************
*** 384,391 ****
  			'parent' => $menu_id,
  			'id'     => $menu_id . '-v',
  			'title'  => __( 'Visit Site' ),
! 			'href'   => get_home_url( $blog->userblog_id, '/' ),
  		) );
  	}
  }
  
--- 385,394 ----
  			'parent' => $menu_id,
  			'id'     => $menu_id . '-v',
  			'title'  => __( 'Visit Site' ),
! 			'href'   => home_url( '/' ),
  		) );
+ 
+ 		restore_current_blog();
  	}
  }
  
***************
*** 417,432 ****
   * @since 3.1.0
   */
  function wp_admin_bar_edit_menu( $wp_admin_bar ) {
! 	global $post, $tag, $wp_the_query;
  
  	if ( is_admin() ) {
  		$current_screen = get_current_screen();
  
  		if ( 'post' == $current_screen->base
  			&& 'add' != $current_screen->action
  			&& ( $post_type_object = get_post_type_object( $post->post_type ) )
  			&& current_user_can( $post_type_object->cap->read_post, $post->ID )
! 			&& ( $post_type_object->public ) )
  		{
  			$wp_admin_bar->add_menu( array(
  				'id' => 'view',
--- 420,437 ----
   * @since 3.1.0
   */
  function wp_admin_bar_edit_menu( $wp_admin_bar ) {
! 	global $tag, $wp_the_query;
  
  	if ( is_admin() ) {
  		$current_screen = get_current_screen();
+ 		$post = get_post();
  
  		if ( 'post' == $current_screen->base
  			&& 'add' != $current_screen->action
  			&& ( $post_type_object = get_post_type_object( $post->post_type ) )
  			&& current_user_can( $post_type_object->cap->read_post, $post->ID )
! 			&& ( $post_type_object->public )
! 			&& ( $post_type_object->show_in_admin_bar ) )
  		{
  			$wp_admin_bar->add_menu( array(
  				'id' => 'view',
***************
*** 453,459 ****
  		if ( ! empty( $current_object->post_type )
  			&& ( $post_type_object = get_post_type_object( $current_object->post_type ) )
  			&& current_user_can( $post_type_object->cap->edit_post, $current_object->ID )
! 			&& ( $post_type_object->show_ui || 'attachment' == $current_object->post_type ) )
  		{
  			$wp_admin_bar->add_menu( array(
  				'id' => 'edit',
--- 458,464 ----
  		if ( ! empty( $current_object->post_type )
  			&& ( $post_type_object = get_post_type_object( $current_object->post_type ) )
  			&& current_user_can( $post_type_object->cap->edit_post, $current_object->ID )
! 			&& $post_type_object->show_ui && $post_type_object->show_in_admin_bar )
  		{
  			$wp_admin_bar->add_menu( array(
  				'id' => 'edit',
***************
*** 484,513 ****
  
  	$cpts = (array) get_post_types( array( 'show_in_admin_bar' => true ), 'objects' );
  
! 	if ( isset( $cpts['post'] ) && current_user_can( $cpts['post']->cap->edit_posts ) ) {
  		$actions[ 'post-new.php' ] = array( $cpts['post']->labels->name_admin_bar, 'new-post' );
- 		unset( $cpts['post'] );
- 	}
  
! 	if ( current_user_can( 'upload_files' ) )
! 		$actions[ 'media-new.php' ] = array( _x( 'Media', 'add new from admin bar' ), 'new-media' );
  
  	if ( current_user_can( 'manage_links' ) )
  		$actions[ 'link-add.php' ] = array( _x( 'Link', 'add new from admin bar' ), 'new-link' );
  
! 	if ( isset( $cpts['page'] ) && current_user_can( $cpts['page']->cap->edit_posts ) ) {
  		$actions[ 'post-new.php?post_type=page' ] = array( $cpts['page']->labels->name_admin_bar, 'new-page' );
! 		unset( $cpts['page'] );
! 	}
  
  	// Add any additional custom post types.
  	foreach ( $cpts as $cpt ) {
! 		if ( ! current_user_can( $cpt->cap->edit_posts ) )
  			continue;
  
  		$key = 'post-new.php?post_type=' . $cpt->name;
  		$actions[ $key ] = array( $cpt->labels->name_admin_bar, 'new-' . $cpt->name );
  	}
  
  	if ( current_user_can( 'create_users' ) || current_user_can( 'promote_users' ) )
  		$actions[ 'user-new.php' ] = array( _x( 'User', 'add new from admin bar' ), 'new-user' );
--- 489,519 ----
  
  	$cpts = (array) get_post_types( array( 'show_in_admin_bar' => true ), 'objects' );
  
! 	if ( isset( $cpts['post'] ) && current_user_can( $cpts['post']->cap->create_posts ) )
  		$actions[ 'post-new.php' ] = array( $cpts['post']->labels->name_admin_bar, 'new-post' );
  
! 	if ( isset( $cpts['attachment'] ) && current_user_can( 'upload_files' ) )
! 		$actions[ 'media-new.php' ] = array( $cpts['attachment']->labels->name_admin_bar, 'new-media' );
  
  	if ( current_user_can( 'manage_links' ) )
  		$actions[ 'link-add.php' ] = array( _x( 'Link', 'add new from admin bar' ), 'new-link' );
  
! 	if ( isset( $cpts['page'] ) && current_user_can( $cpts['page']->cap->create_posts ) )
  		$actions[ 'post-new.php?post_type=page' ] = array( $cpts['page']->labels->name_admin_bar, 'new-page' );
! 
! 	unset( $cpts['post'], $cpts['page'], $cpts['attachment'] );
  
  	// Add any additional custom post types.
  	foreach ( $cpts as $cpt ) {
! 		if ( ! current_user_can( $cpt->cap->create_posts ) )
  			continue;
  
  		$key = 'post-new.php?post_type=' . $cpt->name;
  		$actions[ $key ] = array( $cpt->labels->name_admin_bar, 'new-' . $cpt->name );
  	}
+ 	// Avoid clash with parent node and a 'content' post type.
+ 	if ( isset( $actions['post-new.php?post_type=content'] ) )
+ 		$actions['post-new.php?post_type=content'][1] = 'add-new-content';
  
  	if ( current_user_can( 'create_users' ) || current_user_can( 'promote_users' ) )
  		$actions[ 'user-new.php' ] = array( _x( 'User', 'add new from admin bar' ), 'new-user' );
***************
*** 614,619 ****
--- 620,626 ----
  		return;
  
  	$title = '<span class="ab-icon"></span><span class="ab-label">' . number_format_i18n( $update_data['counts']['total'] ) . '</span>';
+ 	$title .= '<span class="screen-reader-text">' . $update_data['title'] . '</span>';
  
  	$wp_admin_bar->add_menu( array(
  		'id'    => 'updates',
***************
*** 635,641 ****
  		return;
  
  	$form  = '<form action="' . esc_url( home_url( '/' ) ) . '" method="get" id="adminbarsearch">';
! 	$form .= '<input class="adminbar-input" name="s" id="adminbar-search" tabindex="10" type="text" value="" maxlength="150" />';
  	$form .= '<input type="submit" class="adminbar-button" value="' . __('Search') . '"/>';
  	$form .= '</form>';
  
--- 642,648 ----
  		return;
  
  	$form  = '<form action="' . esc_url( home_url( '/' ) ) . '" method="get" id="adminbarsearch">';
! 	$form .= '<input class="adminbar-input" name="s" id="adminbar-search" type="text" value="" maxlength="150" />';
  	$form .= '<input type="submit" class="adminbar-button" value="' . __('Search') . '"/>';
  	$form .= '</form>';
  
***************
*** 723,729 ****
  	global $show_admin_bar, $pagenow;
  
  	// For all these types of requests, we never want an admin bar.
! 	if ( defined('XMLRPC_REQUEST') || defined('APP_REQUEST') || defined('DOING_AJAX') || defined('IFRAME_REQUEST') )
  		return false;
  
  	// Integrated into the admin.
--- 730,736 ----
  	global $show_admin_bar, $pagenow;
  
  	// For all these types of requests, we never want an admin bar.
! 	if ( defined('XMLRPC_REQUEST') || defined('DOING_AJAX') || defined('IFRAME_REQUEST') )
  		return false;
  
  	// Integrated into the admin.
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/author-template.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/author-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/author-template.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/author-template.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 69,76 ****
   * @return string The author's display name.
   */
  function get_the_modified_author() {
! 	global $post;
! 	if ( $last_id = get_post_meta($post->ID, '_edit_last', true) ) {
  		$last_user = get_userdata($last_id);
  		return apply_filters('the_modified_author', $last_user->display_name);
  	}
--- 69,75 ----
   * @return string The author's display name.
   */
  function get_the_modified_author() {
! 	if ( $last_id = get_post_meta( get_post()->ID, '_edit_last', true) ) {
  		$last_user = get_userdata($last_id);
  		return apply_filters('the_modified_author', $last_user->display_name);
  	}
***************
*** 164,171 ****
   * @return int The number of posts by the author.
   */
  function get_the_author_posts() {
! 	global $post;
! 	return count_user_posts($post->post_author);
  }
  
  /**
--- 163,169 ----
   * @return int The number of posts by the author.
   */
  function get_the_author_posts() {
! 	return count_user_posts( get_post()->post_author );
  }
  
  /**
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/bookmark.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/bookmark.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/bookmark.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/bookmark.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 33,43 ****
  			$_bookmark = & $GLOBALS['link'];
  		} elseif ( ! $_bookmark = wp_cache_get($bookmark, 'bookmark') ) {
  			$_bookmark = $wpdb->get_row($wpdb->prepare("SELECT * FROM $wpdb->links WHERE link_id = %d LIMIT 1", $bookmark));
! 			$_bookmark->link_category = array_unique( wp_get_object_terms($_bookmark->link_id, 'link_category', array('fields' => 'ids')) );
! 			wp_cache_add($_bookmark->link_id, $_bookmark, 'bookmark');
  		}
  	}
  
  	$_bookmark = sanitize_bookmark($_bookmark, $filter);
  
  	if ( $output == OBJECT ) {
--- 33,48 ----
  			$_bookmark = & $GLOBALS['link'];
  		} elseif ( ! $_bookmark = wp_cache_get($bookmark, 'bookmark') ) {
  			$_bookmark = $wpdb->get_row($wpdb->prepare("SELECT * FROM $wpdb->links WHERE link_id = %d LIMIT 1", $bookmark));
! 			if ( $_bookmark ) {
! 				$_bookmark->link_category = array_unique( wp_get_object_terms( $_bookmark->link_id, 'link_category', array( 'fields' => 'ids' ) ) );
! 				wp_cache_add( $_bookmark->link_id, $_bookmark, 'bookmark' );
! 			}
  		}
  	}
  
+ 	if ( ! $_bookmark )
+ 		return $_bookmark;
+ 
  	$_bookmark = sanitize_bookmark($_bookmark, $filter);
  
  	if ( $output == OBJECT ) {
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/bookmark-template.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/bookmark-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/bookmark-template.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/bookmark-template.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 42,48 ****
   *
   * @since 2.1.0
   * @access private
-  * @usedby wp_list_bookmarks()
   *
   * @param array $bookmarks List of bookmarks to traverse
   * @param string|array $args Optional. Overwrite the defaults.
--- 42,47 ----
***************
*** 79,85 ****
  		if ( $show_updated )
  			if ( '00' != substr($bookmark->link_updated_f, 0, 2) ) {
  				$title .= ' (';
! 				$title .= sprintf(__('Last updated: %s'), date(get_option('links_updated_date_format'), $bookmark->link_updated_f + (get_option('gmt_offset') * 3600)));
  				$title .= ')';
  			}
  
--- 78,84 ----
  		if ( $show_updated )
  			if ( '00' != substr($bookmark->link_updated_f, 0, 2) ) {
  				$title .= ' (';
! 				$title .= sprintf(__('Last updated: %s'), date(get_option('links_updated_date_format'), $bookmark->link_updated_f + (get_option('gmt_offset') * HOUR_IN_SECONDS)));
  				$title .= ')';
  			}
  
***************
*** 189,195 ****
   * @link http://codex.wordpress.org/Template_Tags/wp_list_bookmarks
   *
   * @since 2.1.0
!  * @uses _list_bookmarks() Used to iterate over all of the bookmarks and return
   *		the html
   * @uses get_terms() Gets all of the categories that are for links.
   *
--- 188,194 ----
   * @link http://codex.wordpress.org/Template_Tags/wp_list_bookmarks
   *
   * @since 2.1.0
!  * @uses _walk_bookmarks() Used to iterate over all of the bookmarks and return
   *		the html
   * @uses get_terms() Gets all of the categories that are for links.
   *
***************
*** 216,224 ****
  	$output = '';
  
  	if ( $categorize ) {
! 		//Split the bookmarks into ul's for each category
! 		$cats = get_terms('link_category', array('name__like' => $category_name, 'include' => $category, 'exclude' => $exclude_category, 'orderby' => $category_orderby, 'order' => $category_order, 'hierarchical' => 0));
  
  		foreach ( (array) $cats as $cat ) {
  			$params = array_merge($r, array('category'=>$cat->term_id));
  			$bookmarks = get_bookmarks($params);
--- 215,227 ----
  	$output = '';
  
  	if ( $categorize ) {
! 		$cats = get_terms( 'link_category', array( 'name__like' => $category_name, 'include' => $category, 'exclude' => $exclude_category, 'orderby' => $category_orderby, 'order' => $category_order, 'hierarchical' => 0 ) );
! 		if ( empty( $cats ) )
! 			$categorize = false;
! 	}
  
+ 	if ( $categorize ) {
+ 		// Split the bookmarks into ul's for each category
  		foreach ( (array) $cats as $cat ) {
  			$params = array_merge($r, array('category'=>$cat->term_id));
  			$bookmarks = get_bookmarks($params);
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/cache.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/cache.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/cache.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/cache.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 180,185 ****
--- 180,200 ----
  }
  
  /**
+  * Switch the interal blog id.
+  *
+  * This changes the blog id used to create keys in blog specific groups.
+  *
+  * @since 3.5.0
+  *
+  * @param int $blog_id Blog ID
+  */
+ function wp_cache_switch_to_blog( $blog_id ) {
+ 	global $wp_object_cache;
+ 
+ 	return $wp_object_cache->switch_to_blog( $blog_id );
+ }
+ 
+ /**
   * Adds a group or set of groups to the list of global groups.
   *
   * @since 2.6.0
***************
*** 189,195 ****
  function wp_cache_add_global_groups( $groups ) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->add_global_groups($groups);
  }
  
  /**
--- 204,210 ----
  function wp_cache_add_global_groups( $groups ) {
  	global $wp_object_cache;
  
! 	return $wp_object_cache->add_global_groups( $groups );
  }
  
  /**
***************
*** 205,216 ****
  }
  
  /**
!  * Reset internal cache keys and structures. If the cache backend uses global blog or site IDs as part of its cache keys,
!  * this function instructs the backend to reset those keys and perform any cleanup since blog or site IDs have changed since cache init.
   *
   * @since 2.6.0
   */
  function wp_cache_reset() {
  	global $wp_object_cache;
  
  	return $wp_object_cache->reset();
--- 220,242 ----
  }
  
  /**
!  * Reset internal cache keys and structures. If the cache backend uses global
!  * blog or site IDs as part of its cache keys, this function instructs the
!  * backend to reset those keys and perform any cleanup since blog or site IDs
!  * have changed since cache init.
!  *
!  * This function is deprecated. Use wp_cache_switch_to_blog() instead of this
!  * function when preparing the cache for a blog switch. For clearing the cache
!  * during unit tests, consider using wp_cache_init(). wp_cache_init() is not
!  * recommended outside of unit tests as the performance penality for using it is
!  * high.
   *
   * @since 2.6.0
+  * @deprecated 3.5.0
   */
  function wp_cache_reset() {
+ 	_deprecated_function( __FUNCTION__, '3.5' );
+ 
  	global $wp_object_cache;
  
  	return $wp_object_cache->reset();
***************
*** 271,276 ****
--- 297,311 ----
  	var $global_groups = array();
  
  	/**
+ 	 * The blog prefix to prepend to keys in non-global groups.
+ 	 *
+ 	 * @var int
+ 	 * @access private
+ 	 * @since 3.5.0
+ 	 */
+ 	var $blog_prefix;
+ 
+ 	/**
  	 * Adds data to the cache if it doesn't already exist.
  	 *
  	 * @uses WP_Object_Cache::_exists Checks to see if the cache already has data.
***************
*** 292,298 ****
  		if ( empty( $group ) )
  			$group = 'default';
  
! 		if ( $this->_exists($key, $group) )
  			return false;
  
  		return $this->set($key, $data, $group, $expire);
--- 327,337 ----
  		if ( empty( $group ) )
  			$group = 'default';
  
! 		$id = $key;
! 		if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) )
! 			$id = $this->blog_prefix . $key;
! 
! 		if ( $this->_exists( $id, $group ) )
  			return false;
  
  		return $this->set($key, $data, $group, $expire);
***************
*** 308,315 ****
  	function add_global_groups( $groups ) {
  		$groups = (array) $groups;
  
! 		$this->global_groups = array_merge($this->global_groups, $groups);
! 		$this->global_groups = array_unique($this->global_groups);
  	}
  
  	/**
--- 347,354 ----
  	function add_global_groups( $groups ) {
  		$groups = (array) $groups;
  
! 		$groups = array_fill_keys( $groups, true );
! 		$this->global_groups = array_merge( $this->global_groups, $groups );
  	}
  
  	/**
***************
*** 323,328 ****
--- 362,373 ----
  	 * @return false|int False on failure, the item's new value on success.
  	 */
  	function decr( $key, $offset = 1, $group = 'default' ) {
+ 		if ( empty( $group ) )
+ 			$group = 'default';
+ 
+ 		if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) )
+ 			$key = $this->blog_prefix . $key;
+ 
  		if ( ! $this->_exists( $key, $group ) )
  			return false;
  
***************
*** 358,363 ****
--- 403,411 ----
  		if ( empty( $group ) )
  			$group = 'default';
  
+ 		if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) )
+ 			$key = $this->blog_prefix . $key;
+ 
  		if ( ! $force && ! $this->_exists( $key, $group ) )
  			return false;
  
***************
*** 399,404 ****
--- 447,455 ----
  		if ( empty( $group ) )
  			$group = 'default';
  
+ 		if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) )
+ 			$key = $this->blog_prefix . $key;
+ 
  		if ( $this->_exists( $key, $group ) ) {
  			$found = true;
  			$this->cache_hits += 1;
***************
*** 427,432 ****
--- 478,486 ----
  		if ( empty( $group ) )
  			$group = 'default';
  
+ 		if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) )
+ 			$key = $this->blog_prefix . $key;
+ 
  		if ( ! $this->_exists( $key, $group ) )
  			return false;
  
***************
*** 455,480 ****
  	 * @param int $expire When to expire the cache contents
  	 * @return bool False if not exists, true if contents were replaced
  	 */
! 	function replace($key, $data, $group = 'default', $expire = '') {
  		if ( empty( $group ) )
  			$group = 'default';
  
! 		if ( ! $this->_exists( $key, $group ) )
  			return false;
  
! 		return $this->set($key, $data, $group, $expire);
  	}
  
  	/**
  	 * Reset keys
  	 *
  	 * @since 3.0.0
  	 */
  	function reset() {
  		// Clear out non-global caches since the blog ID has changed.
! 		foreach ( array_keys($this->cache) as $group ) {
! 			if ( !in_array($group, $this->global_groups) )
! 				unset($this->cache[$group]);
  		}
  	}
  
--- 509,541 ----
  	 * @param int $expire When to expire the cache contents
  	 * @return bool False if not exists, true if contents were replaced
  	 */
! 	function replace( $key, $data, $group = 'default', $expire = '' ) {
  		if ( empty( $group ) )
  			$group = 'default';
  
! 		$id = $key;
! 		if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) )
! 			$id = $this->blog_prefix . $key;
! 
! 		if ( ! $this->_exists( $id, $group ) )
  			return false;
  
! 		return $this->set( $key, $data, $group, $expire );
  	}
  
  	/**
  	 * Reset keys
  	 *
  	 * @since 3.0.0
+ 	 * @deprecated 3.5.0
  	 */
  	function reset() {
+ 		_deprecated_function( __FUNCTION__, '3.5', 'switch_to_blog()' );
+ 
  		// Clear out non-global caches since the blog ID has changed.
! 		foreach ( array_keys( $this->cache ) as $group ) {
! 			if ( ! isset( $this->global_groups[ $group ] ) )
! 				unset( $this->cache[ $group ] );
  		}
  	}
  
***************
*** 502,508 ****
  		if ( empty( $group ) )
  			$group = 'default';
  
! 		if ( is_object($data) )
  			$data = clone $data;
  
  		$this->cache[$group][$key] = $data;
--- 563,572 ----
  		if ( empty( $group ) )
  			$group = 'default';
  
! 		if ( $this->multisite && ! isset( $this->global_groups[ $group ] ) )
! 			$key = $this->blog_prefix . $key;
! 
! 		if ( is_object( $data ) )
  			$data = clone $data;
  
  		$this->cache[$group][$key] = $data;
***************
*** 530,540 ****
  	}
  
  	/**
  	 * Utility function to determine whether a key exists in the cache.
! 	 * @access private
  	 */
! 	protected function _exists($key, $group) {
! 		return isset( $this->cache[$group] ) && is_array( $this->cache[$group] ) && array_key_exists( $key, $this->cache[$group] );
  	}
  
  	/**
--- 594,621 ----
  	}
  
  	/**
+ 	 * Switch the interal blog id.
+ 	 *
+ 	 * This changes the blog id used to create keys in blog specific groups.
+ 	 *
+ 	 * @since 3.5.0
+ 	 *
+ 	 * @param int $blog_id Blog ID
+ 	 */
+ 	function switch_to_blog( $blog_id ) {
+ 		$blog_id = (int) $blog_id;
+ 		$this->blog_prefix = $this->multisite ? $blog_id . ':' : '';
+ 	}
+ 
+ 	/**
  	 * Utility function to determine whether a key exists in the cache.
! 	 *
! 	 * @since 3.4.0
! 	 *
! 	 * @access protected
  	 */
! 	protected function _exists( $key, $group ) {
! 		return isset( $this->cache[ $group ] ) && ( isset( $this->cache[ $group ][ $key ] ) || array_key_exists( $key, $this->cache[ $group ] ) );
  	}
  
  	/**
***************
*** 544,554 ****
  	 * @return null|WP_Object_Cache If cache is disabled, returns null.
  	 */
  	function __construct() {
  		/**
  		 * @todo This should be moved to the PHP4 style constructor, PHP5
  		 * already calls __destruct()
  		 */
! 		register_shutdown_function(array(&$this, "__destruct"));
  	}
  
  	/**
--- 625,641 ----
  	 * @return null|WP_Object_Cache If cache is disabled, returns null.
  	 */
  	function __construct() {
+ 		global $blog_id;
+ 
+ 		$this->multisite = is_multisite();
+ 		$this->blog_prefix =  $this->multisite ? $blog_id . ':' : '';
+ 
+ 
  		/**
  		 * @todo This should be moved to the PHP4 style constructor, PHP5
  		 * already calls __destruct()
  		 */
! 		register_shutdown_function( array( $this, '__destruct' ) );
  	}
  
  	/**
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/canonical.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/canonical.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/canonical.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/canonical.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 18,24 ****
   * one or the other.
   *
   * Prevents redirection for feeds, trackbacks, searches, comment popup, and
!  * admin URLs. Does not redirect on IIS, page/post previews, and on form data.
   *
   * Will also attempt to find the correct link when a user enters a URL that does
   * not exist based on exact WordPress query. Will instead try to parse the URL
--- 18,26 ----
   * one or the other.
   *
   * Prevents redirection for feeds, trackbacks, searches, comment popup, and
!  * admin URLs. Does not redirect on non-pretty-permalink-supporting IIS 7,
!  * page/post previews, WP admin, Trackbacks, robots.txt, searches, or on POST
!  * requests.
   *
   * Will also attempt to find the correct link when a user enters a URL that does
   * not exist based on exact WordPress query. Will instead try to parse the URL
***************
*** 37,43 ****
  function redirect_canonical( $requested_url = null, $do_redirect = true ) {
  	global $wp_rewrite, $is_IIS, $wp_query, $wpdb;
  
! 	if ( is_trackback() || is_search() || is_comments_popup() || is_admin() || !empty($_POST) || is_preview() || is_robots() || $is_IIS )
  		return;
  
  	if ( !$requested_url ) {
--- 39,45 ----
  function redirect_canonical( $requested_url = null, $do_redirect = true ) {
  	global $wp_rewrite, $is_IIS, $wp_query, $wpdb;
  
! 	if ( is_trackback() || is_search() || is_comments_popup() || is_admin() || !empty($_POST) || is_preview() || is_robots() || ( $is_IIS && !iis7_supports_permalinks() ) )
  		return;
  
  	if ( !$requested_url ) {
***************
*** 280,286 ****
  
  		if ( 'wp-register.php' == basename( $redirect['path'] ) ) {
  			if ( is_multisite() )
! 				$redirect_url = apply_filters( 'wp_signup_location', site_url( 'wp-signup.php' ) );
  			else
  				$redirect_url = site_url( 'wp-login.php?action=register' );
  			wp_redirect( $redirect_url, 301 );
--- 282,288 ----
  
  		if ( 'wp-register.php' == basename( $redirect['path'] ) ) {
  			if ( is_multisite() )
! 				$redirect_url = apply_filters( 'wp_signup_location', network_site_url( 'wp-signup.php' ) );
  			else
  				$redirect_url = site_url( 'wp-login.php?action=register' );
  			wp_redirect( $redirect_url, 301 );
